<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_CreditCardFee ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_CreditCardFee extends AbstractStructArrayBase
{
    /**
     * The CreditCardFee
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_CreditCardFee[]
     */
    public $CreditCardFee;
    /**
     * Constructor method for ArrayOfJP_CreditCardFee
     * @uses ArrayOfJP_CreditCardFee::setCreditCardFee()
     * @param \StructType\JP_CreditCardFee[] $creditCardFee
     */
    public function __construct(array $creditCardFee = array())
    {
        $this
            ->setCreditCardFee($creditCardFee);
    }
    /**
     * Get CreditCardFee value
     * @return \StructType\JP_CreditCardFee[]|null
     */
    public function getCreditCardFee()
    {
        return $this->CreditCardFee;
    }
    /**
     * This method is responsible for validating the values passed to the setCreditCardFee method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCreditCardFee method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCreditCardFeeForArrayConstraintsFromSetCreditCardFee(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_CreditCardFeeCreditCardFeeItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CreditCardFeeCreditCardFeeItem instanceof \StructType\JP_CreditCardFee) {
                $invalidValues[] = is_object($arrayOfJP_CreditCardFeeCreditCardFeeItem) ? get_class($arrayOfJP_CreditCardFeeCreditCardFeeItem) : sprintf('%s(%s)', gettype($arrayOfJP_CreditCardFeeCreditCardFeeItem), var_export($arrayOfJP_CreditCardFeeCreditCardFeeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CreditCardFee property can only contain items of type \StructType\JP_CreditCardFee, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CreditCardFee value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CreditCardFee[] $creditCardFee
     * @return \ArrayType\ArrayOfJP_CreditCardFee
     */
    public function setCreditCardFee(array $creditCardFee = array())
    {
        // validation for constraint: array
        if ('' !== ($creditCardFeeArrayErrorMessage = self::validateCreditCardFeeForArrayConstraintsFromSetCreditCardFee($creditCardFee))) {
            throw new \InvalidArgumentException($creditCardFeeArrayErrorMessage, __LINE__);
        }
        $this->CreditCardFee = $creditCardFee;
        return $this;
    }
    /**
     * Add item to CreditCardFee value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CreditCardFee $item
     * @return \ArrayType\ArrayOfJP_CreditCardFee
     */
    public function addToCreditCardFee(\StructType\JP_CreditCardFee $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_CreditCardFee) {
            throw new \InvalidArgumentException(sprintf('The CreditCardFee property can only contain items of type \StructType\JP_CreditCardFee, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CreditCardFee[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_CreditCardFee|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_CreditCardFee|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_CreditCardFee|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_CreditCardFee|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_CreditCardFee|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CreditCardFee
     */
    public function getAttributeName()
    {
        return 'CreditCardFee';
    }
}
